$crystal = 1000000                                          'orajel
$regfile = "m16def.dat"                                     'Mega16-os IC lesz
$baud = 9600                                                'ha van sorosport, akkor az 9600-as kommunikci

Config Portb = Output                                       'szmjegy
Config Porta = Output                                       'szmjegy
Config Portc = Output                                       'szmjegy
Config Pind.2 = Input                                       'CLK
Config Pind.5 = Input                                       'Up/Down
Portd.5 = 1                                                 'bels felhz ellenlls
Config Pind.6 = Output                                      '200/000
Config Pind.7 = Output                                      'Ez a futsjelz LED
Portd.7 = 1

Config Timer0 = Timer , Prescale = 1024
Stop Timer0
On Timer0 Timer0_isr


Dim Szamlalo As Byte                                        'Tolteny

Dim Szazas As Byte
Dim Tizes As Byte
Dim Egyes As Byte
Dim Temp1 As Byte
Dim Temp2 As Byte
Dim Szamjegy(10) As Byte                                    '7szegmens
Dim Ciklusatfutas As Byte                                   'ez hatarozza meg a 200 eleresekor a villogasi utemet


'7szegmenses kijelzo kodjai
Szamjegy(1) = &B11111100
Szamjegy(2) = 96
Szamjegy(3) = 218
Szamjegy(4) = 242
Szamjegy(5) = 102
Szamjegy(6) = 182
Szamjegy(7) = 190
Szamjegy(8) = 224
Szamjegy(9) = 254
Szamjegy(10) = 246


'clk jel a 16-os (PortD.2-es) labra. A lefuto elre 1-t lep a szamlalo, Kulonben semmit.

Config Int0 = Falling                                       'clkra ugorjon ha van, es dobjon el mindent lefuto elre (felfuto eseten Rising kell)
On Int0 Updown                                              'clk-kor ide ugorjon azonnal
Enable Interrupts                                           'megszakitas engedelyezve
Enable Int0                                                 'int0 is engedelyezve:)
Enable Timer0
Start Timer0

'programmag

Porta = 16                                                  'kezdoanimacio
Waitms 100
Porta = 40
Waitms 100
Porta = 108
Waitms 100
Porta = 68
Waitms 100
Porta = 68                                                  
Portb = 128                                                 
Portc = 128                                                
Waitms 100
Porta = 0
Portb = 128
Portc = 128
Waitms 100
Portb = 132
Portc = 192
Waitms 100
Portb = 4
Portc = 64
Waitms 100
Portb = 12
Portc = 96
Waitms 100
Portb = 8
Portc = 32
Waitms 100
Portb = 24
Portc = 48
Waitms 100
Portb = 16
Portc = 16
Waitms 100
Portb = 16
Portc = 16
Porta = 16
Waitms 100
Porta = 56
Portb = 56
Portc = 56
Waitms 100
Porta = 124
Portb = 124
Portc = 124
Waitms 100
Porta = 252
Portb = 252
Portc = 252
Waitms 400

Szamlalo = 0
Ciklusatfutas = 0
Do

'Szamlalo = Szamlalo + 1


'szamjegyek meghatarozasa
Disable Int0
Szazas = Szamlalo / 100
Temp1 = Szazas * 100
Temp1 = Szamlalo - Temp1
Tizes = Temp1 / 10
Temp2 = Tizes * 10
Egyes = Temp1 - Temp2
Enable Int0

'szamjegyek kiiratasa
Szazas = Szazas + 1
Tizes = Tizes + 1
Egyes = Egyes + 1


Ciklusatfutas = Ciklusatfutas + 1
Temp1 = Ciklusatfutas Mod 2

If Szamlalo >= 200 Then
   If Temp1 = 0 Then
      Porta = Szamjegy(tizes)
      Portb = Szamjegy(szazas)
      Portc = Szamjegy(egyes)
      Else
      Porta = 1
      Portb = 1
      Portc = 1
   End If
   Waitms 255
End If

If Szamlalo = 0 Then
   If Temp1 = 0 Then
      Porta = Szamjegy(tizes)
      Portb = Szamjegy(szazas)
      Portc = Szamjegy(egyes)
      Else
      Porta = 1
      Portb = 1
      Portc = 1
   End If
   Waitms 100
End If


If Szamlalo < 200 Then
   Porta = Szamjegy(tizes)
   Portb = Szamjegy(szazas)
   Portc = Szamjegy(egyes)
End If





'200/000 lab valtasa
'If Szamlalo >= 200 Then Portd.6 = 1                         'ha a szamlalo >=200 a portD6 magas szintre kerul
If Szamlalo = 0 Then
   If Portd.6 = 1 Then
      Portd.6 = 0
      Else
      Portd.6 = 1
      Waitms 40
   End If


End If                                                      'ha a szamlalo =0 a portD6 magas szintre kerul
'If Szamlalo > 0 Then                                        'minden egyeb esetben (szamlalo>0 _s_ <200) alacsonyra
'   If Szamlalo < 200 Then
 '     Portd.6 = 0
'   End If
'End If

'Waitms 250


Loop                                                        'nyomas a program elejere



Updown:
If Pind.5 = 1 Then
   Szamlalo = Szamlalo + 2
   Else
   Szamlalo = Szamlalo - 1
End If

If Szamlalo = 255 Then Szamlalo = 0                         '0-1=255! Kifogyott a ta'r
If Szamlalo > 200 Then Szamlalo = 200                       'csak 200-ig szamolhat fel


Return

Timer0_isr:
Toggle Portd.7
Return